package blatt6;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;

import java.sql.SQLException;
import java.sql.Statement;

import java.util.Properties;

public class Setup {

	
	public static String driver = "org.apache.derby.jdbc.EmbeddedDriver";
	public static String protocol = "jdbc:derby:";

	 public static void main(String[] args) {
		try {
			Setup s = new Setup();
			
			s.createDB();
			System.out.print("Grundgehalt");
			s.createGehalt();
			System.out.println();
			System.out.print("Ortszuschlag");
			s.createOrtszuschlag();
			System.out.println();
			System.out.print("Allg. Zulage");
			s.createAllgZulage();
			System.out.println();
			s.stop();
			
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
     private Connection conn = null; 
     private Properties props = new Properties();
    
     private Statement s;
	
	public Setup() throws InstantiationException, IllegalAccessException, ClassNotFoundException{
    	 Class.forName(driver).newInstance();
    		
    	 props.put("user", "user1");
         props.put("password", "user1");
     }
	
	private void createAllgZulage() throws SQLException {
		s.execute("create table allg_zulage(gruppe varchar(10), betrag  float)");
		 
		 s.execute("insert into allg_zulage values('I', 42.98)");
		 s.execute("insert into allg_zulage values('Ia', 42.98)");
		 s.execute("insert into allg_zulage values('Ib', 42.98)");
		 System.out.print(".");
		 
		 s.execute("insert into allg_zulage values('IIa', 114.60)");
		 s.execute("insert into allg_zulage values('IIb', 114.60)");
		 s.execute("insert into allg_zulage values('III', 114.60)");
		 s.execute("insert into allg_zulage values('IVa', 114.60)");
		 s.execute("insert into allg_zulage values('IVb', 114.60)");
		 s.execute("insert into allg_zulage values('Va', 114.60)");
		 s.execute("insert into allg_zulage values('Vb', 114.60)");
		 System.out.print(".");
		 
		 s.execute("insert into allg_zulage values('Vc', 107.44)");
		 s.execute("insert into allg_zulage values('VIa', 107.44)");
		 s.execute("insert into allg_zulage values('VIb', 107.44)");
		 s.execute("insert into allg_zulage values('VII', 107.44)");
		 s.execute("insert into allg_zulage values('VIII', 107.44)");
		 System.out.print(".");
		 
		 s.execute("insert into allg_zulage values('IXa', 90.97)");
		 s.execute("insert into allg_zulage values('IXb', 90.97)");
		 s.execute("insert into allg_zulage values('X', 90.97)");
		 System.out.print(".");
		 conn.commit();
	
}
    private void createDB() throws SQLException{
		  conn = DriverManager.getConnection(protocol +
                  "/home/rguderlei/uni/vorlesungen/sep/6/db;create=true", props);

          conn.setAutoCommit(true);

          s = conn.createStatement();
	}
	
	private void createGehalt() throws SQLException, IOException{
		   BufferedReader r = new BufferedReader(new FileReader("/home/rguderlei/uni/vorlesungen/sep/6/batw.txt"));
	       s.execute("create table bat(gruppe varchar(10), dienstalter integer, gehalt float)");
	            
            String line;
            while((line = r.readLine())!=null){
            	String[] elems = line.split(" ");
       
            	String gehalt = (elems[2].equals("–"))? "NULL": elems[2];
            	String query = "insert into bat values ('" + elems[0] + "'," + elems[1] + "," + gehalt + " )";
             	System.out.print(".");
            	s.execute(query);
            }
         
            
            conn.commit();
     
            
	}

	    private void createOrtszuschlag() throws SQLException, IOException {
			 s.execute("create table ortszuschlag(id integer, stufe integer, betrag float)");
			 s.execute("create table zuordnung_ortszuschlag(gruppe varchar(10), id integer)");
			 
			 s.execute("insert into zuordnung_ortszuschlag values('I', 0)");
			 s.execute("insert into zuordnung_ortszuschlag values('Ia', 0)");
			 s.execute("insert into zuordnung_ortszuschlag values('Ib', 0)");
			 s.execute("insert into zuordnung_ortszuschlag values('IIa', 0)");
			 s.execute("insert into zuordnung_ortszuschlag values('IIb', 0)");
			 
			 s.execute("insert into zuordnung_ortszuschlag values('III', 1)");
			 s.execute("insert into zuordnung_ortszuschlag values('IVa', 1)");
			 s.execute("insert into zuordnung_ortszuschlag values('IVb', 1)");
			 s.execute("insert into zuordnung_ortszuschlag values('Va', 1)");
			 s.execute("insert into zuordnung_ortszuschlag values('Vb', 1)");
			 
			 s.execute("insert into zuordnung_ortszuschlag values('Vc', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('VIa', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('VIb', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('VII', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('VIII', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('IXa', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('IXb', 2)");
			 s.execute("insert into zuordnung_ortszuschlag values('X', 2)");
			 conn.commit();
			 BufferedReader r = new BufferedReader(new FileReader("/home/rguderlei/uni/vorlesungen/sep/6/ortszuschlag2.txt"));
	            
            String line;
            while((line = r.readLine())!=null){
            	String[] elems = line.split(" ");
            	String query = "insert into ortszuschlag values (" + elems[0] + "," + elems[1] + "," + elems[2] + " )";
             	System.out.print(".");
            	s.execute(query);
            }
            
            conn.commit();
	}

		private void stop(){
			try{
					s.close();
			  		conn.close();
		            DriverManager.getConnection("jdbc:derby:;shutdown=true");
		            System.out.println("Connection closed.");
		    }
		    catch (SQLException se){
		    		se.printStackTrace();
		    }

		}

		

	   

}
